<template>
    <div>
      <q-tabs
        v-model="tab"
        dense
        flat
        class="text-grey q-mb-lg"
        active-color="primary"
        indicator-color="primary"
        align="justify"
      >
        <q-tab name="runs" label="Runs" />
        <q-tab name="issues">
          <div class="text-h7">
            Issues
            <q-badge align="top" color="red">4</q-badge>
          </div>
        </q-tab>
      </q-tabs>

      <q-tab-panels v-model="tab" animated>

        <q-tab-panel name="runs">
          <q-table
            dense
            class="no-shadow"
            :rows="rows"
            :columns="columns"
            :row-key="job">

      <template v-slot:body="props">
        <q-tr :props="props">
          <q-td key="job" :props="props">
              <div class="col col-10"><a :href="getJobLink(props.row.job)">{{ props.row.job.name }}</a><br /><a :href="getPipelineLink(props.row.pipeline)">{{ props.row.pipeline }}</a></div>
          </q-td>
          <q-td key="runner" :props="props">
          {{ props.row.runner }}
          </q-td>
          <q-td key="duration" :props="props">{{ props.row.duration }}</q-td>
          <q-td key="result" :props="props">
            <q-badge :color="props.row.color" text-color="white" :label="props.row.result" class="text-uppercase"/>
          </q-td>
          <q-td key="artifacts" :props="props">
              <q-icon name="fas fa-cloud-download-alt" size="xs"  style="color: #ccc;"/>
          </q-td>
          <q-td key="output" :props="props">
              <q-icon name="fas fa-terminal" size="xs"  style="color: #ccc;"/>
          </q-td>

        </q-tr>
      </template>

          </q-table>
        </q-tab-panel>

        <q-tab-panel name="issues">
          <div class="text-h6">Issues</div>
          TODO: A list of issues related to this test, could be displayed here.
        </q-tab-panel>
      </q-tab-panels>
     </div>
</template>

<script>

const columns = [
  {name: 'job', label: 'Job Information', align: 'left', field: 'job', sortable: false},
  {name: 'runner', label: 'Runner', align: 'left', field: 'runner', sortable: true},
  {name: 'duration', label: 'Duration', field: 'duration', sortable: true},
  {name: 'result', label: 'Result', field: 'result', sortable: true},
  {name: 'artifacts', label: 'Artifacts', align: 'center', field: 'artifacts', sortable: false},
  {name: 'output', label: 'Output', align: 'center', field: 'output', sortable: false}]

const conf = config()

import { ref } from 'vue'

export default {
  setup () {
    return {
      tab: ref('runs'),
      splitterModel: ref(20),
      columns,
    }
  },
  data () {
    return {
      rows: []
    }
  },
  created () {
    this.emitter.on('tests.summary.selected', (row) => {
       fetch(conf.I4C_API_SERVER + "/projects/2/tests/" + row.id)
         .then(response => response.json())
         .then(data => (this.update(data, row)));
    })
  },
  methods: {
    getJobLink (job) {
       return job.external_url
    },
    getPipelineLink (pipeline) {
       // Fix this to support multiple projects
       return "https://gitlab.com/qemu-project/qemu/-/pipelines/" + pipeline
    },
    update (data, row) {
       console.log("Data", data)
       console.log("Row", row)
       let result = []
       let colors = {'failed': 'warning',
                     'success': 'positive',
                     'error': 'negative',
                     'skipped': 'secondary'}


       data['test_results'].forEach(function(el) {
          result.push({'job': el.job,
                       'pipeline': el.job.pipeline,
                       'stage': el.job.stage,
                       'duration': el.execution_time.toFixed(2),
                       'result': el.status,
                       'runner': el.job.runner,
                       'color': colors[el.status]})
       })
       this.rows = result
    }
  }
}
</script>
